from django.shortcuts import render,redirect
from django.contrib.auth.decorators import login_required,user_passes_test
from django.utils.decorators import method_decorator
#from mainApp.serializers import *
#from mainApp.models import *
from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework import status
#import json , requests
from django.conf import settings as stg
from datetime import datetime,date,timedelta
from django.db.models import Count,Sum,Max,F
import json
from django.db.models import Max
from django.utils import timezone
from itertools import chain # Join Multiple Querysets From Different Base Models Django
from django.db.models import Q
from clmainApp.utils import getBranchId,getDayName
from clmainApp.models import WeekDay
from brpatientApp.models import Patient
from brvisitApp.models import PatientVisit
from brmainApp.models import Location
from clmainApp.models import FoundWay
from brfinanceApp.models import *
from brpatientApp.serializers import PatientSerializer,PatientMiniSerializer
#from brmainApp.models import ActiveHourSlot,DrWorkingDay,BranchDailyAlertMessage
from brmainApp.models import ActiveHourSlot,DrWorkingDay

from clmainApp.models import User
from .serializers import *
from clmainApp.whatsapp_templates import send_dr_session_notification,send_pt_session_created,send_pt_policy,send_session_payment_notification

# Create your views here.
from brmainApp.utils import getBranchDoctors
class TodaySessionsApi(APIView):# el 7alat elli mfrood yigo inharda 
    @method_decorator(user_passes_test(lambda u: u.has_perm('Reception.view_todayPatients'), login_url='/main/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        timezone_now_today = timezone.now().date()
        all_patients =Patient.objects.filter(branch=branchId).values("id","fullname","code",'number_1','number_2','rfid')
        branch_doctors = getBranchDoctors(branchId)
        #serializer_patients=PatientMiniSerializer(all_patients,many=True)
        medical_sessions =Session.objects.filter(branch=branchId)
        all_found_ways = FoundWay.objects.all()
        all_locations = Location.objects.filter(branch_id= branchId)
        all_expense_items = ExpenseItem.objects.filter(branch_id=branchId).values('id','name','category_id')
        all_expense_categories = ExpenseCategory.objects.all()
        # #ps_items = PatientSessionItem.objects.filter(session_day=timezone_now_today)\
        # Current problematic query:
        #periodicSessionItems = PatientSessionItem.objects.filter(session_day__lte=timezone_now_today,entry_status__in = ["1I","2W","3N"],session__patient__branch_id=branchId).order_by('session_day','hour_slot__order')
        # Optimized version:
        periodicSessionItems = PatientSessionItem.objects.select_related(
            'doctor', 'hour_slot', 'session', 'session__patient', 
            'session__session', 'session_status'
        ).prefetch_related(
            'session__patient__patient_info',
            'session__patient__patient_info__pt_status'
        ).filter(
            session_day__lte=timezone_now_today,
            entry_status__in=["1I","2W","3N"],
            session__patient__branch_id=branchId
        ).order_by('session_day','hour_slot__order').only(
            'id', 'psi_order', 'session_day', 'entry_status',
            'entry_datetime', 'finish_datetime', 'reception_notes',
            'doctor_id', 'hour_slot_id', 'session_id', 'session_status_id'
        )
        #.values("id","psi_order","session__patient__fullname",
        #"session__patient__number_1","session__patient__number_2","session_id","status",
        #"doctor__first_name","doctor__last_name","hour_slot__name","hour_slot__id","session__amount_remaining","session__sessions_count","session__amount_required","session__session__name","reception_notes").order_by("hour_slot")
        #request['status']=periodicSessionItems.get_status_display()
        seralizer = PatientSessionItemCustomSerializer(periodicSessionItems,many=True)
        #branch_messages = BranchDailyAlertMessage.objects.filter(branch_id=branchId)
        branch_messages = None
        active_message= branch_messages[0] if branch_messages else None # هنرسمها زى ما بتترسم فى الجدول الأصلى 
        context={
            #"locations":Location.objects.all(),
            "today":timezone_now_today,
            "all_patients":all_patients,
            #"all_patients":serializer_patients.data,
            "medical_sessions":medical_sessions,
            "all_doctors":branch_doctors,
            "found_ways":all_found_ways,
            "locations":all_locations,
            "all_expense_items":all_expense_items,
            "all_expense_categories":all_expense_categories,
            #"periodicSessionItems":periodicSessionItems,
            "periodicSessionItems":seralizer.data,
            'activePage':'CurrentSessions',
            "active_message":active_message,
            #"session_status":ChoiceField(choices=SESSION_STATUS_CHOICES).choices,
            #"hour_slots":HourSlot.objects.all().order_by('order')
            #"dr_sessions" :dr_sessions,
            #"periodicSessionStatus":PeriodicSessionStatus.objects.all().order_by("order").values("name","id")
            }
        return render(request,"Reception/rcpsessionApp/today_sessions.html",context=context)

from clvoucherApp.models import PatientVoucher
class PatientSessionsApi(APIView):    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.add_PatientSession'), login_url='/main/login/'))    
    def post(self,request):
        #if not getClinicId(request) : return redirect('/main/login/')
        data = request.data
        data._mutable = True
        data.update({"created_by":request.user.id})     
        serializedObj= PatientSessionSerializer(data=data)
        if serializedObj.is_valid():
            serializedObj.save()
            pt_session_id = serializedObj.data["id"]
            used_voucher_id = data.get('used_voucher_id',None)
            if used_voucher_id != "0" and used_voucher_id != None :
                PatientVoucher.objects.filter(id=used_voucher_id).update(is_used_session=True,pt_session_id=pt_session_id)
            return Response(pt_session_id, status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
############## PatientVisit%Module #################
def get_new_code_value(all_patients):
    max_code = all_patients.aggregate(Max('code'))
    if max_code["code__max"] : new_code_value = int(max_code["code__max"])+1
    else : new_code_value = 1
    return new_code_value

##############  PhysicalSessions%Module #################

###### PatientSessions   ########
import timeit
import pandas as pd
#from django.db.models import Q
#from clmainApp.whatsapp__old import *
from brpatientApp.models import PatientInfo
class SessionDaysApi(APIView):
    def get_object(self,pk):
        try:
            return PatientSession.objects.get(pk=pk)
        except PatientSession.DoesNotExist:
            return None
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_PatientSessionItem'), login_url='/main/login/'))        
    def get(self,request,session_pk):
        branchId = getBranchId(request)
        context={}
        patient_sessionObj=self.get_object(session_pk)
        if patient_sessionObj :
            start_time = timeit.default_timer()
            context.update({"pS":PatientSessionSerializer(patient_sessionObj).data})
            waiting_session_items =None
            if waiting_session_items : start_date  = waiting_session_items.first().session_day
            else : start_date = timezone.now().date()
            days_count = 21
            end_date =  start_date + timedelta(days_count)
            weekdays = WeekDay.objects.filter(is_active=True)
            hourSlots = ActiveHourSlot.objects.filter(branch_id = branchId).values('hour_slot_id','hour_slot__name').order_by('hour_slot__order')
            end_date = start_date + timedelta(days_count)
            days_data = []
            #make  all absence  slots aavailable
            patientSessionItems = PatientSessionItem.objects.filter(session_day__range =[start_date,end_date],session_status_id__in=["1NW","2AT"]).values('hour_slot','session_day','doctor_id') 
            #patientSessionItems = PatientSessionItem.objects.filter(session_day__range =[start_date,end_date],session_status_id__in=["1NW","2AT","3AB1","4AB2","5AB3"]).values('hour_slot','session_day','doctor_id')
            branch_doctors = User.objects.filter(user_category="2DR",groups__branch_id=branchId).values("id","name")
            doctors_working_days = DrWorkingDay.objects.filter(dr_id__in=branch_doctors.values_list('id',flat=True)).values("dr_id","weekday_id")
            context.update({'doctors':branch_doctors,"hourSlots":hourSlots})
            ps_items_df = pd.DataFrame(patientSessionItems)
            dwd_df = pd.DataFrame(doctors_working_days)
            for i in range (0,days_count,1):
                day_date =  start_date + timedelta(i)
                if not weekdays.filter(code=day_date.weekday()):continue
                day_ = weekdays.get(code=day_date.weekday())
                day_name = day_.name
                day_color = day_.color_hexa
                obj={}
                obj["day"] ={"day_name":day_name,"day_date":day_date,"day_color":day_color}
                #ps_items_filtered = ps_items_df[ps_items_df["session_day"]==day_date]
                if not ps_items_df.empty :
                    ps_items_filtered = ps_items_df[ps_items_df["session_day"]==day_date]
                else :
                    ps_items_filtered = pd.DataFrame()
                obj["doctors_data"]=[]
                if len(ps_items_filtered):#ps items in this day
                    for dr in branch_doctors:
                        if len(dwd_df[(dwd_df["dr_id"]==dr["id"])&(dwd_df["weekday_id"]==day_.id)]) == 0 : continue
                        dr_obj = {"dr_id":dr["id"],"dr_name":dr["name"]}
                        dr_obj["dr_slots"]=[]
                        ps_items_dr_df = ps_items_filtered[ps_items_filtered['doctor_id']==dr["id"]]
                        if len(ps_items_dr_df)==0:#doctor doesnt have any slot 
                            dr_obj["dr_slots"]=[{"s_id":s['hour_slot_id'],"s_name":s['hour_slot__name'],"is_checked":False} for s in hourSlots]
                        else :
                            for s in hourSlots :
                                session_dr_slot_df = ps_items_dr_df[ps_items_dr_df["hour_slot"]==s['hour_slot_id']]
                                is_checked = True if  len(session_dr_slot_df)>0 else False
                                slotObj = {"s_id":s['hour_slot_id'],"s_name":s['hour_slot__name'],"is_checked":is_checked}
                                dr_obj["dr_slots"].append(slotObj)
                        obj["doctors_data"].append(dr_obj)
                else :
                    for dr in branch_doctors:
                        if len(dwd_df[(dwd_df["dr_id"]==dr["id"])&(dwd_df["weekday_id"]==day_.id)]) == 0 : continue
                        dr_obj = {"dr_id":dr["id"],"dr_name":dr["name"]}
                        dr_obj["dr_slots"]=[{"s_id":s['hour_slot_id'],"s_name":s['hour_slot__name'],"is_checked":False} for s in hourSlots]
                        obj["doctors_data"].append(dr_obj)
                days_data.append(obj)
            end_time = timeit.default_timer()
            #print(f"Time taken for iteration: {end_time - start_time} seconds")
            context.update({'days_data':days_data})
            context.update({'activePage':'CurrentSessions'})
        return render(request,"Reception/rcpsessionApp/session_days_new.html",context,)
    
    def post(self,request,session_pk):# periodic session id 
        data = request.data
        sessions_data_json = data['sessions_data']
        is_send_wa_msg = data['send_wa_msg']
        sessions_data = json.loads(sessions_data_json)
        items_list = []
        pt_ssn_obj = PatientSession.objects.get(id=session_pk)
        counter = int(pt_ssn_obj.sessions_done) + 1 
        try :
            PatientSessionItem.objects.filter(session_id=session_pk,entry_status__in=["2W","3N"]).delete()
            for psi in sessions_data :
                items_list.append(PatientSessionItem(session_day=psi["session_day"],hour_slot_id=psi["hour_slot"],session_id=session_pk,doctor_id=psi["doctor"],psi_order = counter,created_by=request.user,session_status_id="1NW"))
                counter = counter + 1
            PatientSessionItem.objects.bulk_create(items_list)
            if is_send_wa_msg == "True" :
                patient_obj = pt_ssn_obj.patient
                pt_fullname = patient_obj.fullname
                pt_number_1 = patient_obj.number_1
                pt_name = "أهلا بحضرتك / {}\n شكرا لثقتك فى مراكز NoPainClinic \n".format(pt_fullname)
                sessions_count = "تم تخصيص / {} جلسات\n".format(len(items_list))
                #total_paid = pt_ssn_obj.initial_payment + pt_ssn_obj.related_payment
                sessions_string=""
                for psi in items_list:
                    day_name = getDayName(datetime.strptime(psi.session_day, '%Y-%m-%d').date().weekday())
                    ssn_str = "{}/{} {}({})\n".format(psi.psi_order,day_name,psi.hour_slot.name,psi.session_day)
                    sessions_string=sessions_string + ssn_str
                payment = "المدفوع:{}  المتبقى:{}جنيها  \n".format(pt_ssn_obj.initial_payment,pt_ssn_obj.amount_remaining)
                msg_footer = "من فضلك قم بحفظ هذا الرقم علي هاتفك لضمان وصول جميع التنبيهات بطريقة صحيحة"
                message_text = pt_name + sessions_count + sessions_string + payment + msg_footer
                is_msg_sent = send_pt_session_created(pt_number_1,True,message_text)
                #is_msg_sent=False
                if is_msg_sent :
                    msg_status = "تم إرسال تفاصيل الجلسات  بنجاح "
                    pt_ssn_obj.is_initial_wa_sent=True
                else : 
                    msg_status = "لم نتمكن من إرسال تفاصيل الجلسات"
                    pt_ssn_obj.is_initial_wa_sent=False
                pt_ssn_obj.save()
                policy_status = ""
                if not patient_obj.is_wa_policy_sent :
                    #is_policy_sent=False
                    #print("start send_pt_policy")
                    is_policy_sent = send_pt_policy(pt_number_1,True,pt_fullname)
                    #print("start send_pt_policy",is_policy_sent)
                    if is_policy_sent :
                        policy_status = "تم إرسال اللائحة للمريض بنجاح "
                        Patient.objects.filter(pk=patient_obj.id).update(is_wa_policy_sent=True)
            else :
                msg_status = "لم نتمكن من إرسال تفاصيل الجلسات"
                pt_ssn_obj.is_initial_wa_sent=False
                pt_ssn_obj.save()
                policy_status = ""
            return Response({"msg_status":msg_status,"policy_status":policy_status},status=status.HTTP_201_CREATED)
        except Exception as err_msg:
            return Response("{}".format(str(err_msg)),status=status.HTTP_400_BAD_REQUEST)

            #return Response({"err_msg":err_msg},status=status.HTTP_400_BAD_REQUEST)

'''
from django.db.models import Q
from clmainApp.whatsapp import *
class SessionDaysApi(APIView):
    def get_object(self,pk):
        try:
            return PatientSession.objects.get(pk=pk)
        except PatientSession.DoesNotExist:
            return None
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_PatientSessionItem'), login_url='/main/login/'))        
    def get(self,request,session_pk):
        branchId = getBranchId(request)
        context={}
        patient_sessionObj=self.get_object(session_pk)
        if patient_sessionObj :
            start_time = timeit.default_timer()
            context.update({"pS":PatientSessionSerializer(patient_sessionObj).data})
            waiting_session_items =None
            if waiting_session_items : start_date  = waiting_session_items.first().session_day
            else : start_date = timezone.now().date()
            days_count = 21
            end_date =  start_date + timedelta(days_count)
            weekdays = WeekDay.objects.filter(is_active=True)
            hourSlots = ActiveHourSlot.objects.filter(branch_id = branchId).values('hour_slot_id','hour_slot__name').order_by('hour_slot__order')
            end_date = start_date + timedelta(days_count)
            days_data = []
            #print("weekdays - hourSlots",timezone.now())
            patientSessionItems = PatientSessionItem.objects.filter(session_day__range =[start_date,end_date],session_status_id__in=["1NW","2AT","3AB1","4AB2","5AB3"]).values('hour_slot','session_day','doctor_id')
            #print("patientSessionItems",timezone.now())
            branch_doctors = User.objects.filter(user_category="2DR",groups__branch_id=branchId).values("id","name")
            #print("branch_doctors",timezone.now())
            doctors_working_days = DrWorkingDay.objects.filter(dr_id__in=branch_doctors.values_list('id',flat=True))
            print("doctors_working_days",timezone.now())
            context.update({'doctors':branch_doctors,"hourSlots":hourSlots})
            for i in range (0,days_count,1):
                day_date =  start_date + timedelta(i)
                ps_items = patientSessionItems.filter(session_day=day_date)
                if not weekdays.filter(code=day_date.weekday()):continue
                day_ = weekdays.get(code=day_date.weekday())
                day_name = day_.name
                day_color = day_.color_hexa
                obj={}
                obj["day"] ={"day_name":day_name,"day_date":day_date,"day_color":day_color}
                obj["doctors_data"]=[]
                print("before branch_doctors",timezone.now())
                for dr in branch_doctors:
                    if not doctors_working_days.filter(dr_id=dr["id"],weekday_id=day_.id) : continue
                    dr_obj = {"dr_id":dr["id"],"dr_name":dr["name"]}
                    dr_obj["dr_slots"]=[]
                    for s in hourSlots : 
                        #session_dr_slot = ps_items.filter(hour_slot_id=s['hour_slot_id'],doctor_id=dr["id"],~Q(id=3))
                        session_dr_slot = ps_items.filter(hour_slot_id=s['hour_slot_id'],doctor_id=dr["id"])
                        #is_checked =False
                        is_checked = True if  session_dr_slot else False
                        slotObj = {"s_id":s['hour_slot_id'],"s_name":s['hour_slot__name'],"is_checked":is_checked}
                        dr_obj["dr_slots"].append(slotObj)
                    obj["doctors_data"].append(dr_obj)                   
                days_data.append(obj)
            end_time = timeit.default_timer()
            print(f"Time taken for iteration: {end_time - start_time} seconds")
            context.update({'days_data':days_data})
            context.update({'activePage':'CurrentSessions'})
        return render(request,"Reception/rcpsessionApp/session_days_new.html",context,)
    
    def post(self,request,session_pk):# periodic session id 
        data = request.data
        sessions_data_json = data['sessions_data'] 
        sessions_data = json.loads(sessions_data_json)
        items_list = []
        #import pdb
        #pdb.set_trace()
        pt_ssn_obj = PatientSession.objects.get(id=session_pk)
        counter = int(pt_ssn_obj.sessions_done) + 1 
        try :
            PatientSessionItem.objects.filter(session_id=session_pk,entry_status__in=["2W","3N"]).delete()
            for psi in sessions_data :
                items_list.append(PatientSessionItem(session_day=psi["session_day"],hour_slot_id=psi["hour_slot"],session_id=session_pk,doctor_id=psi["doctor"],psi_order = counter,created_by=request.user,session_status_id="1NW"))
                counter = counter + 1
            PatientSessionItem.objects.bulk_create(items_list)
            #import pdb
            #+20 100 172 4148
            # pt_name = "أهلا بكم / {}\n".format(pt_ssn_obj.patient.fullname)
            # sessions_count = "تم تخصيص / {} جلسات\n".format(len(items_list))
            # dr_name = "الطبيب / {}\n".format(items_list[0].doctor.name)
            # payment = "المدفوع:{}  المتبقى:{}جنيها  \n".format(pt_ssn_obj.initial_payment,pt_ssn_obj.amount_remaining)
            # sessions_string = ""
            # for psi in items_list:
            #     day_name = getDayName(datetime.strptime(psi.session_day, '%Y-%m-%d').date().weekday())
            #     #pdb.set_trace()
            #     ssn_str = "{}/{} {}({})\n".format(psi.psi_order,day_name,psi.hour_slot.name,psi.session_day)
            #     sessions_string=sessions_string + ssn_str
            # is_msg_sent = send_message('+201018223004',1,"".join([pt_name, sessions_count,dr_name,sessions_string,payment]))
            # if is_msg_sent :
            #     msg_status = "تم إرسال التفاصيل الى الواتساب بنجاح "
            # else : msg_status = "لم نتمكن من إرسال التفاصيل الى الواتساب "
            # #pdb.set_trace()
            # pt_ssn_obj.is_initial_wa_sent=True
            # pt_ssn_obj.save()
            msg_status  = "تم إرسال التفاصيل الى الواتساب بنجاح "
            is_msg_sent = True
            return Response({"is_msg_sent":is_msg_sent,"msg_status":msg_status},status=status.HTTP_201_CREATED)
        except Exception as err_msg:
            return Response("{}".format(str(err_msg)),status=status.HTTP_400_BAD_REQUEST)

            #return Response({"err_msg":err_msg},status=status.HTTP_400_BAD_REQUEST)

'''
class SessionDaysEditApi(APIView):
    def get_object(self,pk):
        try:
            return PatientSession.objects.get(pk=pk)
        except PatientSession.DoesNotExist:
            return None
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_PatientSessionItem'), login_url='/main/login/'))        
    def get(self, request, session_pk):
        branchId = getBranchId(request)
        context = {}

        patient_sessionObj = self.get_object(session_pk)
        if not patient_sessionObj:
            return render(request, "Reception/rcpsessionApp/session_days_edit.html", context)

        context["pS"] = PatientSessionSerializer(patient_sessionObj).data

        # Preload all related hour slots to avoid repeated queries
        session_items = list(
            PatientSessionItem.objects.filter(session_id=session_pk).select_related("hour_slot")
        )

        # Classify session items once
        finished_session_items = [item for item in session_items if item.entry_status in ["1I", "4F", "5A"]]
        unfinished_session_items = sorted(
            [item for item in session_items if item.entry_status not in ["1I", "4F", "5A"]],
            key=lambda x: x.session_day
        )

        context["finished_session_items"] = finished_session_items

        if unfinished_session_items:
            context.update({
                "unfinished_doctor_id": unfinished_session_items[0].doctor_id,
                "unfinished_session_items": [
                    {
                        "session_date": psi.session_day.strftime('%Y-%m-%d'),
                        "session_slot_id": psi.hour_slot_id
                    } for psi in unfinished_session_items
                ]
            })
        else:
            context.update({"unfinished_doctor_id": 0, "unfinished_session_items": []})

        # Period range
        today = timezone.now().date()
        first_session_date = unfinished_session_items[0].session_day if unfinished_session_items else today
        start_date = min(today, first_session_date)
        days_count = 21
        end_date = start_date + timedelta(days_count)

        weekdays = WeekDay.objects.filter(is_active=True)
        weekdays_dict = {w.code: w for w in weekdays}

        hourSlots = list(
            ActiveHourSlot.objects.filter(branch_id=branchId)
            .select_related('hour_slot')
            .values('hour_slot_id', 'hour_slot__name')
            .order_by('hour_slot__order')
        )

        # Patient session items in the target range (excluding current session)
        patient_session_items_qs = PatientSessionItem.objects.filter(
            session_day__range=[start_date, end_date],
            session_status_id__in=["1NW", "2AT"]
        ).exclude(
            session_id=session_pk,
            entry_status__in=["2W", "3N"]
        ).values('hour_slot', 'session_day', 'doctor_id')

        # Build a fast lookup map: (day, slot, doctor) -> True
        psi_map = {
            (psi["session_day"], psi["hour_slot"], psi["doctor_id"]): True
            for psi in patient_session_items_qs
        }

        # Doctors and their workdays
        branch_doctors = list(
            User.objects.filter(user_category="2DR", groups__branch_id=branchId)
            .values("id", "name")
        )
        doctor_ids = [dr["id"] for dr in branch_doctors]

        # Set of tuples (doctor_id, weekday_id)
        working_days_set = set(
            DrWorkingDay.objects.filter(dr_id__in=doctor_ids)
            .values_list("dr_id", "weekday_id")
        )

        context.update({
            'doctors': branch_doctors,
            "hourSlots": hourSlots
        })

        days_data = []
        for i in range(days_count):
            day_date = start_date + timedelta(i)
            weekday_code = day_date.weekday()

            if weekday_code not in weekdays_dict:
                continue

            day_ = weekdays_dict[weekday_code]

            obj = {
                "day": {
                    "day_name": day_.name,
                    "day_date": day_date,
                    "day_color": day_.color_hexa
                },
                "doctors_data": []
            }

            for dr in branch_doctors:
                if (dr["id"], day_.id) not in working_days_set:
                    continue

                dr_obj = {
                    "dr_id": dr["id"],
                    "dr_name": dr["name"],
                    "dr_slots": []
                }

                for s in hourSlots:
                    key = (day_date, s['hour_slot_id'], dr["id"])
                    is_checked = key in psi_map

                    dr_obj["dr_slots"].append({
                        "s_id": s['hour_slot_id'],
                        "s_name": s['hour_slot__name'],
                        "is_checked": is_checked
                    })

                obj["doctors_data"].append(dr_obj)

            days_data.append(obj)

        context.update({
            'days_data': days_data,
            'activePage': 'CurrentSessions'
        })

        return render(request, "Reception/rcpsessionApp/session_days_edit.html", context)


    
    def post(self,request,session_pk):# periodic session id 
        data = request.data
        sessions_data_json = data['sessions_data'] 
        sessions_data = json.loads(sessions_data_json)
        items_list = []
        counter = (PatientSession.objects.get(id=session_pk).sessions_done) + 1 
        try :
            PatientSessionItem.objects.filter(session_id=session_pk,entry_status__in=["2W","3N"]).delete()
            for psi in sessions_data :
                items_list.append(PatientSessionItem(session_day=psi["session_day"],hour_slot_id=psi["hour_slot"],session_id=session_pk,doctor_id=psi["doctor"],psi_order = counter,created_by=request.user,session_status_id="1NW"))
                counter = counter + 1
            PatientSessionItem.objects.bulk_create(items_list)
            return Response(status=status.HTTP_201_CREATED)
        except Exception as err_msg:
            return Response({"err_msg":err_msg},status=status.HTTP_400_BAD_REQUEST)

    # def post(self,request,session_pk):# periodic session id 
    #     data = request.data
    #     sessions_data_json = data['sessions_data'] 
    #     sessions_data = json.loads(sessions_data_json)
    #     items_list = []
    #     counter = (PatientSession.objects.get(id=session_pk).sessions_done) + 1 
    #     try :
    #         PatientSessionItem.objects.filter(session_id=session_pk,entry_status__in=["2W","3N"]).delete()
    #         for psi in sessions_data :
    #             items_list.append(PatientSessionItem(session_day=psi["session_day"],hour_slot_id=psi["hour_slot"],session_id=session_pk,doctor_id=psi["doctor"],psi_order = counter,created_by=request.user,session_status_id="1NW"))
    #             counter = counter + 1
    #         PatientSessionItem.objects.bulk_create(items_list)
    #         return Response(status=status.HTTP_201_CREATED)
    #     except Exception as err_msg:
    #         return Response({"err_msg":err_msg},status=status.HTTP_400_BAD_REQUEST)
class PatientSessionItemsApi(APIView):
    def get(self,request,session_id):
        ps_items = PatientSessionItem.objects.filter(session_id=session_id).order_by('session_day')
        serializer= PatientSessionItemCustomSerializer(ps_items,many=True)
        return Response(serializer.data , status=status.HTTP_200_OK)

class PatientSessionItemApi(APIView):
    def get_object(self,pk):
        try:
            return PatientSessionItem.objects.get(pk=pk)
        except PatientSessionItem.DoesNotExist:
            return None    
    # def get(self,request,pk):
    #     obj=self.get_object(pk)
    #     if obj :
    #         ps_items = PatientSessionItem.objects.filter(session=obj.session).order_by('session_day')
    #         serializer= PatientSessionItemSerializer(ps_items,many=True)
    #         return Response(serializer.data , status=status.HTTP_200_OK)
    #     else :return Response({"error":"No sessions found"},status=status.HTTP_400_BAD_REQUEST)

    def put(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            data = request.data
            data._mutable = True
            if 'entry_status' in data :
                if data['entry_status'] == '1I' :
                    entry_datetime = timezone.now()
                    dr_number = data["dr_number"]
                    dr_name = data["dr_name"]
                    hourslot_name = data["hourslot_name"]
                    pt_name = data["pt_name"]
                    #(dr_number,is_priority_instant,pt_name,dr_name,hourslot_name,entry_datetime)
                    is_wa_confirm_sent = send_dr_session_notification(dr_number,True,pt_name,dr_name,hourslot_name,entry_datetime)
                    
                    data.update({"entry_datetime":entry_datetime,"is_wa_confirm_sent":is_wa_confirm_sent})
                if data["entry_status"] == "4F": data.update({"finish_datetime":timezone.now()})

            #request.data.update({"updated_by":request.user.id})
            serializer= PatientSessionItemSerializer(obj,data,partial=True)
            if serializer.is_valid():
                serializer.save()
                if 'entry_status' in data :
                    if data['entry_status'] == '1I': 
                        ps = PatientSession.objects.get(id=obj.session_id)
                        total_done_sessions = PatientSessionItem.objects.filter(session_id=obj.session_id,entry_status__in=["1I","4F"]).count()
                        # total_done_sessions + ps.sessions_absence اللى هو عملهم قبل كده هزود عليهم  لو فى غياب   
                        ps.sessions_done = total_done_sessions 
                        ps.sessions_remain = ps.sessions_count - (total_done_sessions + ps.sessions_absence )
                        ps.sessions_done_cost = ps.sessions_done * ps.session_price
                        ps.save()
                        patient_id = ps.patient_id
                        #كشف بدأ جلسات --- ملحوظة الدكتور مفيش حد بيبدأ جلسات إلا لما يكشف عن الدكتور 
                        PatientInfo.objects.filter(patient_id=patient_id).update(marketing_code="V_S_S",last_session=timezone.now())
            # if "doctor" in data : 
            #     
            #     request.data.update({"status":"1I"})
            # if "finishSession" in data : 
            #     request.data.update({"status":"4F"})

            #     if "amount_paid" in data : 
            #         ps = PatientSession.objects.get(id=obj.session_id)
            #         total_amount_paid = PatientSessionItem.objects.filter(session_id=obj.session_id).aggregate(total=Sum('amount_paid'))
            #         #hageen kol items bta3t el session di w hgm3 initial_payment 3la el floos elli df3ha kol galsa 
            #         ps.amount_paid = ps.initial_payment + total_amount_paid["total"] 
            #         ps.amount_remaining = int(ps.amount_required) -  int(ps.amount_paid)
            #         ps.save()
            #     if "doctor" in data : 
            #         ps = PatientSession.objects.get(id=obj.session_id)
            #         total_done_sessions = PatientSessionItem.objects.filter(session_id=obj.session_id,status__in=["1I","4F"]).count()
            #         ps.sessions_done = total_done_sessions
            #         ps.sessions_remain = ps.sessions_count - total_done_sessions
            #         ps.save()
                return Response(serializer.data , status=status.HTTP_200_OK)
            else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

class PsiAbsenceApi(APIView):
    def get_object(self,pk):
        try:
            return PatientSessionItem.objects.get(pk=pk)
        except PatientSessionItem.DoesNotExist:
            return None    

    def put(self,request,psi_id):
        obj=self.get_object(psi_id)
        if obj :
            #hshof el glsat di 8ab abl kda wlla l2
            #sessionStatus = SessionStatus.objects.all()
            ps_items_data = PatientSessionItem.objects.filter(session_id=obj.session_id).aggregate(max_session_status=Max('session_status__absence_order'))
            max_session_status = ps_items_data["max_session_status"]
            if max_session_status == 0 and obj.session.is_package:
                obj.session_status_id = "3AB1"
                obj.entry_status = "5A"
                obj.save()
                #اول مره يغيب  وهو باقه هزودله جلسه تحدد لما يجي ومش هدفعه فلوس زيادة 
                pt_session = PatientSession.objects.get(id=obj.session_id)
                pt_session.sessions_count = pt_session.sessions_count + 1
                pt_session.sessions_absence = pt_session.sessions_absence + 1
                #pt_session.sessions_remain = pt_session.sessions_remain + 1
                pt_session.save()
            elif max_session_status == 0 and not obj.session.is_package:
                obj.session_status_id = "3AB1"
                obj.entry_status = "5A"
                obj.save()
                pt_session = PatientSession.objects.get(id=obj.session_id)
                pt_session.sessions_absence = pt_session.sessions_absence + 1
                pt_session.sessions_remain = pt_session.sessions_remain - 1
                pt_session.save()
            elif max_session_status == 1 and obj.session.is_package :
                obj.session_status_id = "4AB2"
                obj.entry_status = "5A"
                obj.save()
                pt_session = PatientSession.objects.get(id=obj.session_id)
                pt_session.sessions_absence = pt_session.sessions_absence + 1
                pt_session.sessions_remain = pt_session.sessions_remain - 1
                pt_session.save()
            elif max_session_status == 1 and not obj.session.is_package :
                obj.session_status_id = "4AB2"
                obj.entry_status = "5A"
                obj.save()
                pt_session = PatientSession.objects.get(id=obj.session_id)
                pt_session.sessions_absence = pt_session.sessions_absence + 1
                pt_session.sessions_remain = pt_session.sessions_remain - 1
                pt_session.save()
                #عشان هو مش باقه همسحله المواعيد اللى انا محددهاله بعد كده ولما يجي اعمله من جديد 
                ps_items_next =  PatientSessionItem.objects.filter(session_id=obj.session_id,id__gt=psi_id)
                ps_items_next.delete()
            else :
                obj.session_status_id = "5AB3"
                obj.entry_status = "5A"
                obj.save()
                pt_session = PatientSession.objects.get(id=obj.session_id)
                pt_session.sessions_absence = pt_session.sessions_absence + 1
                pt_session.sessions_remain = pt_session.sessions_remain - 1
                pt_session.save()
            return Response(status=status.HTTP_200_OK)
        else :return Response(status=status.HTTP_400_BAD_REQUEST)
 
class SessionRelatedPaymentsApi(APIView): 
    def get(self,request,pt_ssn_id):
        ptSsn_payments = PtSsnPayment.objects.filter(pt_ssn_id=pt_ssn_id)
        serializer=PtSsnPaymentSerializer(ptSsn_payments,many=True)
        return Response(serializer.data,status=status.HTTP_200_OK)

    def post(self,request,pt_ssn_id):
        data = request.data
        data._mutable = True
        data.update({"pt_ssn":pt_ssn_id})
        data.update({"created_by":request.user.id})
        serializer= PtSsnPaymentSerializer(data=data)
        if serializer.is_valid():
            #send message and check if message sent
            #try :
            amount_paid = int( data["amount_paid"])
            pt_ssn = PatientSession.objects.get(pk=pt_ssn_id)
            total_related_payment = pt_ssn.related_payment + amount_paid
            pt_ssn.related_payment = total_related_payment
            pt_ssn__amount_remaining = pt_ssn.amount_required - ( pt_ssn.amount_paid + total_related_payment)
            pt_ssn.amount_remaining = pt_ssn__amount_remaining
            patient_obj = pt_ssn.patient
            pt_fullname = patient_obj.fullname
            pt_number_1 = patient_obj.number_1
            pt_ssn.save()
            #print(pt_ssn.__dict__)
            serializer.save()
            #pt_ssn = PatientSession.objects.get(id=pt_ssn_id)
            pt_ssn_serializer = PatientSessionSerializer(pt_ssn,many=False)
            response_data = {"updated_obj":pt_ssn_serializer.data}
            try :
                is_msg_sent = send_session_payment_notification(pt_number_1,True,pt_fullname,amount_paid,pt_ssn__amount_remaining,pt_ssn_id)
                if is_msg_sent:
                    new_payment_id = serializer.data ["id"]
                    PtSsnPayment.objects.filter(id=new_payment_id).update(is_wa_sent=True)
                    response_data["wa_status"] = " تم إرسال رسالة الواتساب بنجاح"
                else : response_data["wa_status"] = " عذراً , لم نتمكن من ارسال رسالة الواتساب"
            except Exception as err_msg: response_data["wa_status"] = err_msg
            return Response(response_data,status=status.HTTP_201_CREATED)
        else : return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

#from brmainApp.models import BranchAlertMessage
#الجلسات القادمة 
class RcpAlertMessagesApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('Reception.view_alertMessages'), login_url='/main/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        #branch_messages = BranchAlertMessage.objects.filter(branch_id=branchId)
        branch_messages=[]
        #if branch_messages :
        active_message= branch_messages[0] if branch_messages else None # هنرسمها زى ما بتترسم فى الجدول الأصلى 
        #هنشوف فى الأول خالص لو مفيش رسالة هعرض كود ه ت م ل معين لو فى هعرض الكود العادى 
        return render(request,"Reception/rcpsessionApp/rcp_alert_messages.html",{"active_message":active_message,'activePage':'RcpAlertMessages'})
        #else : return render(request,"error_template with message لا توجد رسالة تنبيه مخصصه لهذا الفرع ",{'activePage':'RcpAlertMessages'})

    def post(self,request):
        branchId = getBranchId(request)
        if not branchId : return Response(status=status.HTTP_400_BAD_REQUEST)
        data = request.data
        selected_day = data["selected_day"]
        day_session_items =  PatientSessionItem.objects.filter(session_day=selected_day,session_status_id="1NW")
        serializer = PatientSessionItemCustomSerializer(day_session_items,many=True)#هنقسمهم cards طبقا لكل دكتور 
        return Response(serializer.data , status=status.HTTP_200_OK)#وهنعمل الزرارين ونبعت منهم الرسايل وهنعمل زرار تعديل ملاحظات الجلسة الاستقبال وتفاصيل الجلسات وزرار تعديل الجلسات 

class NextPeriodSessionsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('Reception.view_nextPeriodSessions'), login_url='/main/login/'))
    def get(self, request):
        branchId = getBranchId(request)
        context = {}
        if not branchId:
            return redirect('clauthApp:home')

        days_count = 21
        start_date = timezone.now().date()
        end_date = start_date + timedelta(days_count)

        # Fetch once and convert to fast-access dict
        weekdays = {w.code: w for w in WeekDay.objects.filter(is_active=True)}

        hourSlots = list(
            ActiveHourSlot.objects.filter(branch_id=branchId)
            .values('hour_slot_id', 'hour_slot__name')
            .order_by('hour_slot__order')
        )

        branch_doctors = list(
            User.objects.filter(user_category="2DR", groups__branch_id=branchId)
            .values("id", "name")
        )
        doctor_ids = [d["id"] for d in branch_doctors]

        working_days_map = {}
        for wd in DrWorkingDay.objects.filter(dr_id__in=doctor_ids).values("dr_id", "weekday_id"):
            working_days_map.setdefault(wd["dr_id"], set()).add(wd["weekday_id"])

        # Fetch all relevant session items only once
        session_items_raw = PatientSessionItem.objects.filter(
            session_day__range=[start_date, end_date],
            session_status_id__in=["1NW", "2AT", "3AB1", "4AB2", "5AB3"]
        ).values("hour_slot", "session_day", "doctor_id", "session__patient__fullname")

        # Build a lookup: (day, hour_slot, doctor) → patient name
        session_map = {}
        for item in session_items_raw:
            key = (item["session_day"], item["hour_slot"], item["doctor_id"])
            session_map[key] = item["session__patient__fullname"]

        context.update({'doctors': branch_doctors, "hourSlots": hourSlots})
        days_data = []

        for i in range(days_count):
            day_date = start_date + timedelta(i)
            weekday_code = day_date.weekday()

            if weekday_code not in weekdays:
                continue

            day_ = weekdays[weekday_code]
            day_name = day_.name
            day_color = day_.color_hexa

            obj = {"day": {"day_name": day_name, "day_date": day_date, "day_color": day_color}, "doctors_data": []}

            for dr in branch_doctors:
                if day_.id not in working_days_map.get(dr["id"], set()):
                    continue

                dr_obj = {"dr_id": dr["id"], "dr_name": dr["name"], "dr_slots": []}

                for slot in hourSlots:
                    key = (day_date, slot["hour_slot_id"], dr["id"])
                    patient_name = session_map.get(key, "")
                    is_checked = bool(patient_name)

                    dr_obj["dr_slots"].append({
                        "s_id": slot["hour_slot_id"],
                        "s_name": slot["hour_slot__name"],
                        "is_checked": is_checked,
                        "patient_name": patient_name
                    })

                obj["doctors_data"].append(dr_obj)
            days_data.append(obj)

        context.update({
            'days_data': days_data,
            'activePage': 'NextPeriodSessions'
        })

        return render(request, "Reception/rcpsessionApp/next_period_sessions.html", context=context)


class RcpPatientSessionsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('Reception.view_patientSessions'), login_url='/auth/login/'))
    def get(self,request):
        # if dr  , get current branch patients
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        all_patients =Patient.objects.filter(
            branch_id=branchId,code__gt=0).values("id","fullname","rfid","code","number_1")
        return render(request,"Reception/rcpsessionApp/rcp_pt_sessions.html",{
            "all_patients":all_patients,'activePage':'RcpPatientSessions'})